//+------------------------------------------------------------------+
//|                                                Ich_Disparity.mq4 |
//|                             original version by Gehtsoft USA LLC |
//|                   corrected version by mladen, www,forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Blue

extern string   TimeFrame = "Current time frame"; // Time frame to use
extern int Disp1_Component1=0;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp1_Length1=14;
extern int Disp1_Method1=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Disp1_Component2=1;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp1_Length2=14;
extern int Disp1_Method2=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Disp2_Component1=0;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp2_Length1=14;
extern int Disp2_Method1=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Disp2_Component2=2;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp2_Length2=14;
extern int Disp2_Method2=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Disp3_Component1=3;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp3_Length1=14;
extern int Disp3_Method1=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Disp3_Component2=4;  // 0 - TL
                                // 1 - KL
                                // 2 - CS
                                // 3 - SA
                                // 4 - SB
extern int Disp3_Length2=14;
extern int Disp3_Method2=0;     // 0 - SMA
                                // 1 - EMA
                                // 2 - SMMA
                                // 3 - LWMA
extern int Ich_Tenkan_Sen=9;
extern int Ich_Kijun_Sen=26;
extern int Ich_Senkou_Span_B=52;

double Disparity1[], Disparity2[], Disparity3[];
double Tenkansen[], Kijunsen[], Senkouspana[], Senkouspanb[], Chinkouspan[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      IndicatorShortName("ICH Disparity oscillator");
      IndicatorDigits(Digits);
      SetIndexBuffer(0,Disparity1);
      SetIndexBuffer(1,Disparity2);
      SetIndexBuffer(2,Disparity3);
      
      SetIndexBuffer(3,Tenkansen);
      SetIndexBuffer(4,Kijunsen);
      SetIndexBuffer(5,Senkouspana);
      SetIndexBuffer(6,Senkouspanb);
      SetIndexBuffer(7,Chinkouspan);

         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

 return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double GetMA(int IchIndex, int Method, int Length, int index)
{
   if (IchIndex==0) return (iMAOnArray(Tenkansen, 0, Length, 0, Method, index));
   if (IchIndex==1) return (iMAOnArray(Kijunsen,  0, Length, 0, Method, index));
   if (IchIndex==2)
      if (index>=Ich_Kijun_Sen)
            return (iMAOnArray(Chinkouspan, 0, Length, 0, Method, index-Ich_Kijun_Sen));
      else  return (EMPTY_VALUE);
   if (IchIndex==3) return (iMAOnArray(Senkouspana, 0, Length, 0, Method, index));
   if (IchIndex==4) return (iMAOnArray(Senkouspanb, 0, Length, 0, Method, index));
   return(EMPTY_VALUE);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double C11, C12, C21, C22, C31, C32; 
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,Ich_Kijun_Sen),Bars-1);
           if (returnBars) { Disparity1[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period())
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     Disparity1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Disp1_Component1,Disp1_Length1,Disp1_Method1,Disp1_Component2,Disp1_Length2,Disp1_Method2,Disp2_Component1,Disp2_Length1,Disp2_Method1,Disp2_Component2,Disp2_Length2,Disp2_Method2,Disp3_Component1,Disp3_Length1,Disp3_Method1,Disp3_Component2,Disp3_Length2,Disp3_Method2,Ich_Tenkan_Sen,Ich_Kijun_Sen,Ich_Senkou_Span_B,0,y);
                     Disparity2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Disp1_Component1,Disp1_Length1,Disp1_Method1,Disp1_Component2,Disp1_Length2,Disp1_Method2,Disp2_Component1,Disp2_Length1,Disp2_Method1,Disp2_Component2,Disp2_Length2,Disp2_Method2,Disp3_Component1,Disp3_Length1,Disp3_Method1,Disp3_Component2,Disp3_Length2,Disp3_Method2,Ich_Tenkan_Sen,Ich_Kijun_Sen,Ich_Senkou_Span_B,1,y);
                     Disparity3[i] = iCustom(NULL,timeFrame,indicatorFileName,"",Disp1_Component1,Disp1_Length1,Disp1_Method1,Disp1_Component2,Disp1_Length2,Disp1_Method2,Disp2_Component1,Disp2_Length1,Disp2_Method1,Disp2_Component2,Disp2_Length2,Disp2_Method2,Disp3_Component1,Disp3_Length1,Disp3_Method1,Disp3_Component2,Disp3_Length2,Disp3_Method2,Ich_Tenkan_Sen,Ich_Kijun_Sen,Ich_Senkou_Span_B,2,y);
               }                   
               return(0);
           }

   //
   //
   //
   //
   //
   
   for(int pos=limit; pos>=0; pos--)
   {
      Tenkansen[pos]  =iIchimoku(NULL, 0, Ich_Tenkan_Sen, Ich_Kijun_Sen, Ich_Senkou_Span_B, MODE_TENKANSEN,   pos);
      Kijunsen[pos]   =iIchimoku(NULL, 0, Ich_Tenkan_Sen, Ich_Kijun_Sen, Ich_Senkou_Span_B, MODE_KIJUNSEN,    pos);
      Senkouspana[pos]=iIchimoku(NULL, 0, Ich_Tenkan_Sen, Ich_Kijun_Sen, Ich_Senkou_Span_B, MODE_SENKOUSPANA, pos);
      Senkouspanb[pos]=iIchimoku(NULL, 0, Ich_Tenkan_Sen, Ich_Kijun_Sen, Ich_Senkou_Span_B, MODE_SENKOUSPANB, pos);
      Chinkouspan[pos]=iIchimoku(NULL, 0, Ich_Tenkan_Sen, Ich_Kijun_Sen, Ich_Senkou_Span_B, MODE_CHINKOUSPAN, pos+Ich_Kijun_Sen);
   } 
   for(pos=limit; pos>=0; pos--)
   {
      C11=GetMA(Disp1_Component1, Disp1_Method1, Disp1_Length1, pos);
      C12=GetMA(Disp1_Component2, Disp1_Method2, Disp1_Length2, pos);
      
         if (C11!=EMPTY_VALUE && C12!=EMPTY_VALUE) Disparity1[pos]=(C11-C12)/Point;
         
      C21=GetMA(Disp2_Component1, Disp2_Method1, Disp2_Length1, pos);
      C22=GetMA(Disp2_Component2, Disp2_Method2, Disp2_Length2, pos);
  
         if (C21!=EMPTY_VALUE && C22!=EMPTY_VALUE) Disparity2[pos]=(C21-C22)/Point;
  
      C31=GetMA(Disp3_Component1, Disp3_Method1, Disp3_Length1, pos);
      C32=GetMA(Disp3_Component2, Disp3_Method2, Disp3_Length2, pos);
      
         if (C31!=EMPTY_VALUE && C32!=EMPTY_VALUE) Disparity3[pos]=(C31-C32)/Point;
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                              return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}